Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members Related Pages

# LayerC Class Reference

Composition Layer class. More...

`#include <LayerC.h>`

Inheritance diagram for LayerC:

List of all members.

## Public Member Functions
virtual Edit::DataBlockI * | create ()
| Creates new layer (used internally), see Edit::EditableI::create().
virtual Edit::DataBlockI * | create (Edit::EditableI *pOriginal)
| Creates new layer (used internally), see Edit::EditableI::create().
virtual void | copy (Edit::EditableI *pEditable)
| Deep copy from a data block, see Edit::DataBlockI::copy().
virtual void | restore (Edit::EditableI *pEditable)
| Shallow copy from a editable, see Edit::EditableI::restore().
void | set_name (const char *szName)
| Sets the name of the layer\. The name is NULL terminated string.
const char * | get_name () const
| Return the name of the layer.
PajaTypes::int32 | get_effect_count ()
| Return number of effects inside the layer.
EffectI * | get_effect (PajaTypes::int32 i32Index)
| Returns effect at specified index.
PajaTypes::int32 | add_effect (EffectI *pEffect)
| Adds new effect to the layer.
void | del_effect (PajaTypes::int32 i32Index)
| Removes and deletes a effect at specified index from the layer.
EffectI * | remove_effect (PajaTypes::int32 i32Index)
| Removes a effect at specified index from list.
void | insert_effect (PajaTypes::int32 i32IndexBefore, EffectI *pEffect)
| Adds a effect to list, the change is not stored to the present undo object.
void | set_flags (PajaTypes::int32 i32Flags)
| Sets the effect flags.
void | add_flags (PajaTypes::int32 i32Flags)
| Sets only specified flags.
void | del_flags (PajaTypes::int32 i32Flags)
| Removes only specified flags.
void | toggle_flags (PajaTypes::int32 i32Flags)
| Toggles only specified flags.
PajaTypes::int32 | get_flags ()
| Returns key flags.
void | set_parent (SceneC *pScene)
| Sets the parent Scene.
SceneC * | get_parent () const
| Gets the parent Scene.
TimeSegmentC * | get_timesegment ()
| Returns the timesegment of the layer.
PajaTypes::uint32 | save (FileIO::SaveC *pSave)
| Serialize the layer to a Demopaja output stream.
PajaTypes::uint32 | load (FileIO::LoadC *pLoad)
| Serialize the layer from a Demopaja input stream.
## Static Public Member Functions
LayerC * | create_new (SceneC *pParent)
| Creates new layer.
## Protected Member Functions
| LayerC (SceneC *pParent)
| Default constructor.
| LayerC (Edit::EditableI *pOriginal)
| Constructor with reference to the original.
virtual | ~LayerC ()
| Default destructor.

## Detailed Description

Composition Layer class.

Layer class is used to group effects and to control their visibility. The layer class used by the Demopaja system and is only exposed to the export plugins. The changes to the layer are stored to a undo object if present.

This class is implemented by the system.

## Constructor & Destructor Documentation

LayerC | ( | SceneC * | pParent | ) | `[protected]`

| Default constructor.

LayerC | ( | Edit::EditableI * | pOriginal | ) | `[protected]`

| Constructor with reference to the original.

virtual ~LayerC | ( |  | ) | `[protected, virtual]`

| Default destructor.

## Member Function Documentation

PajaTypes::int32 add_effect | ( | EffectI * | pEffect | ) |

| Adds new effect to the layer.

void add_flags | ( | PajaTypes::int32 | i32Flags | ) |

| Sets only specified flags.

virtual void copy | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Deep copy from a data block, see Edit::DataBlockI::copy(). Implements EditableI.

virtual Edit::DataBlockI* create | ( | Edit::EditableI * | pOriginal | ) | `[virtual]`

| Creates new layer (used internally), see Edit::EditableI::create(). Implements EditableI.

virtual Edit::DataBlockI* create | ( |  | ) | `[virtual]`

| Creates new layer (used internally), see Edit::EditableI::create(). Implements EditableI.

LayerC* create_new | ( | SceneC * | pParent | ) | `[static]`

| Creates new layer.

void del_effect | ( | PajaTypes::int32 | i32Index | ) |

| Removes and deletes a effect at specified index from the layer.

void del_flags | ( | PajaTypes::int32 | i32Flags | ) |

| Removes only specified flags.

EffectI* get_effect | ( | PajaTypes::int32 | i32Index | ) |

| Returns effect at specified index.

PajaTypes::int32 get_effect_count | ( |  | ) |

| Return number of effects inside the layer.

PajaTypes::int32 get_flags | ( |  | ) |

| Returns key flags.

const char* get_name | ( |  | ) | const

| Return the name of the layer.

SceneC* get_parent | ( |  | ) | const

| Gets the parent Scene.

TimeSegmentC* get_timesegment | ( |  | ) |

| Returns the timesegment of the layer.

void insert_effect | ( | PajaTypes::int32 | i32IndexBefore,
|  | EffectI * | pEffect
| ) |

| Adds a effect to list, the change is not stored to the present undo object.

PajaTypes::uint32 load | ( | FileIO::LoadC * | pLoad | ) | `[virtual]`

| Serialize the layer from a Demopaja input stream. Implements EditableI.

EffectI* remove_effect | ( | PajaTypes::int32 | i32Index | ) |

| Removes a effect at specified index from list. This method removes the effect from the list inside the layer, and retuns the effect. The effect is not deleted. See also: del_effect

virtual void restore | ( | Edit::EditableI * | pEditable | ) | `[virtual]`

| Shallow copy from a editable, see Edit::EditableI::restore(). Implements EditableI.

PajaTypes::uint32 save | ( | FileIO::SaveC * | pSave | ) | `[virtual]`

| Serialize the layer to a Demopaja output stream. Implements EditableI.

void set_flags | ( | PajaTypes::int32 | i32Flags | ) |

| Sets the effect flags. Be careful to use this method. There are some flags, which have to be in place to make the layer work correctly. Use add, del or toggle flags methods instead.

void set_name | ( | const char * | szName | ) |

| Sets the name of the layer\. The name is NULL terminated string.

void set_parent | ( | SceneC * | pScene | ) |

| Sets the parent Scene.

void toggle_flags | ( | PajaTypes::int32 | i32Flags | ) |

| Toggles only specified flags.